#!/usr/bin/env python
#-*- coding: utf-8 -*-
# -*- mode: python -*-

#__author__ = "Aarón Martín Castillo Medina"
#__credits__ = ["Aarón Martín Castillo Medina","Dra. Katya Rodríguez Vázquez"]

#__version__ = "1.0"
#__mantainer__ = "Aarón Martín Castillo Medina"
#__email__ = "amcm329@hotmail.com"
#__status__ = "Production"


#Este archivo permite crear un ejecutable para que M.O.E.A. Software 
#pueda ejecutarse sin dependencias. 

#Además de Python 2.7 y Tkinter se debe instalar PyInstaller solo para crear
#este tipo de ejecutable.

#Por lo general basta usar pip para instalar todo lo necesario, por ejemplo:
#pip install tkinter
#pip install pyinstaller

#Para lo demás, se siguen las siguientes instrucciones: 

#NOTA: antes de ejecutar el comando se tiene que habilitar la ruta ya sea 
#para Windows o Linux dependiendo del sistema operativo y también garantizar
#que el codigo esté en la ruta indicada por dicha variable.

#IMPORTANTE
################Forma de ejecucion en Windows y Linux: /path/to/python -m pyinstaller --onefile Begin.spec ################

#El path to Python es importante porque hay veces que es mejor usar 
#python2 en vez de python3 debido a la antigüedad del paquete pyinstaller.

#La opcion --debug anade un listado del procedimiento paso a paso.
#La opcion --console anade la consola adicional a la interfaz grafica.

#IMPORTANTE 2
#En caso de usar Python2: 
#Se debe instalar python-dev para agregar algunas dependencias extra necesarias para pyinstaller.
#Se debe instalar pip de Python2 para poder instalar pyinstaller (versión 3.6). 
#Úsese esta referencia: https://stackoverflow.com/questions/26266437/how-to-use-python2-7-pip-instead-of-default-pip
#Asegúrese que se instaló pyinstaller dentro de /usr/local de Python2 y no de Python3

block_cipher = None

#VERSION PARA LINUX
nombre_completo = 'MOEA_Software_Linux'
ruta_completa = '/home/usuario/Documentos/ProjectMOEA/Otros/M.O.E.A. Software/Código Fuente'

#VERSION PARA WINDOWS
#nombre_completo = 'MOEA_Software_Windows'
#ruta_completa = ''C:\\Users\\amcm3_000\\Documents\\Tesis\\Codigo Fuente''

#Se ligan todas las clases.
a = Analysis(['Begin.py'],
             pathex=[ruta_completa],
             binaries=None,
             datas=None,
             hiddenimports=[

                              
                            'View',#experimental      
                            'View.MainWindow', #experimental
                            'View.Main', #experimental
                            'View.Additional', #experimental
 
                            
                            'Model.Community.Community',
                            'Model.ChromosomalRepresentation.BinaryRepresentation',
                            'Model.ChromosomalRepresentation.FloatPointRepresentation',
                            'Model.Fitness.ProportionalFitness',
                            'Model.Fitness.LinearRankingFitness',
                            'Model.Fitness.NonLinearRankingFitness',
                            'Model.Operator.Selection.ProbabilisticTournament',
                            'Model.Operator.Selection.Roulette',
                            'Model.Operator.Selection.StochasticUniversalSampling',
                            'Model.Operator.Crossover.NPointsCrossover',
                            'Model.Operator.Crossover.UniformCrossover',
                            'Model.Operator.Mutation.BinaryMutation',
                            'Model.Operator.Mutation.FloatPointMutation',
                            'Model.SharingFunction.GenotypicSimilarity.HammingDistance',
                            'Model.SharingFunction.PhenotypicSimilarity.EuclideanDistance',
                            'Model.MOEA.VEGA',
                            'Model.MOEA.NSGAII',
                            'Model.MOEA.SPEAII',
                            'Model.MOEA.MOGA'
                           ],
             hookspath=[],
             runtime_hooks=[],
             excludes=[],
             win_no_prefer_redirects=False,
             win_private_assemblies=False,
             cipher=block_cipher)

#Se añaden las imágenes como botones, 
#escudos de la UNAM y Facultad de Ciencias
a.datas +=  [('View/Image/delete.gif', ruta_completa + '/View/Image/delete.gif', 'DATA')]
a.datas +=  [('View/Image/delete_mini.gif', ruta_completa + '/View/Image/delete_mini.gif', 'DATA')]
a.datas +=  [('View/Image/unam_shield.gif', ruta_completa + '/View/Image/unam_shield.gif', 'DATA')]
a.datas +=  [('View/Image/sciences_shield.gif', ruta_completa + '/View/Image/sciences_shield.gif', 'DATA')]

a.datas +=  [('View/Image/unam_shield.ico', ruta_completa + '/View/Image/unam_shield.ico', 'DATA')]
a.datas +=  [('View/Image/unam_shield.xbm', ruta_completa + '/View/Image/unam_shield.xbm', 'DATA')]

a.datas +=  [('Controller/XML/Features.xml', ruta_completa + '/Controller/XML/Features.xml', 'DATA')]  
a.datas +=  [('Controller/XML/MOPExamples.xml', ruta_completa + '/Controller/XML/MOPExamples.xml', 'DATA')]
a.datas +=  [('Controller/XML/PythonExpressions.xml', ruta_completa + '/Controller/XML/PythonExpressions.xml', 'DATA')]

pyz = PYZ(a.pure, 
          a.zipped_data,
          cipher=block_cipher
         )

#Se crea el ejecutable.
exe = EXE(pyz,
          a.scripts,
          a.binaries,
          a.zipfiles,
          a.datas,
          name=nombre_completo,
          debug=True,
          strip=False,
          upx=False,
          console=True,
          icon=ruta_completa + '/View/Image/unam_shield.ico'
         )
